local TabUtils=require"Bax.TabUtils"
local TabToStr=TabUtils.TableToString
----------------------------------------------------------------
local Info = package.loaded.regscript or function(...) return ... end
local nfo = Info {_filename or ...,
  name        = "AreaInfo";
  description = "Показывает информацию о текущей области; для диалога - список элементов диалога";
  version     = "1.1.1"; --http://semver.org/lang/ru/
  author      = "BAX";
  url         = "";
  id          = "E71E446A-D2F5-47B4-84DB-A84717B23E17";
  --parent_id   = "";
  --minfarversion = {3,0,0,4744,0};
  --files       = "*.cfg;*.ru.lng";
  --config      = function(nfo,name) end;
  --help        = function(nfo,name) end;
  --execute     = function(nfo,name) end;

  --disabled    = false;
  --options     = {};
}
if not nfo then return end
--local O = nfo.options
----------------------------------------------------------------
Macro{
  id="12D8E6D7-399E-4014-A5BC-65D49B3BDC7D";
  area="Common";
  key="CtrlAltF1-F1";
  description="Показать тип области, ID и состав диалога";
--  filemask="";
  flags="";
--  priority=50;
--  sortpriority=50;
--  condition=function(key) return true end;
action=function()
 local function DlgItemsShow(hDlg)
  if not hDlg then return end
  local aItems={}
  for iItem=1,Dlg.ItemCount do
   local Item=hDlg:send("DM_GETDLGITEM", iItem)
   aItems[iItem] = Item
  end
  for _,v in ipairs(aItems) do
   -- Замена числового типа элемента на название
   for i,w in pairs(far.Flags) do
    if i:match('^DI_') and w==v[1] then
     v[1] = i
     break
    end
   end
   if type(v[9]) == 'number' then
    if v[9] == 0 then
     v[9] = 'DIF_NONE'
    else
     local sFlags=''
     for i,w in pairs(far.Flags) do
      if i:match('^DIF_') and w ~= 0 and band(v[9], w) == w then
       if sFlags ~= '' then sFlags = sFlags .. ',' end
       sFlags = sFlags .. i
       v[9] = bxor(v[9], w)
       if v[9] == 0 then break end
      end
     end
     v[9] = sFlags
    end
   elseif type(v[9]) ~= 'table' then
    v[9] = tostring(v[9])
   end
  end; -- for _,v in ipairs(aItems)

  local function MenuItemsShow()
   local s={}
   if Area.Disks or Area.MainMenu or Area.Menu then
    for i=1,Object.ItemCount do
     local ss=Menu.GetValue(i)
     if ss then
      s[#s+1]=(band(Menu.ItemStatus(i), 1) == 1 and '→' or ' ') ..
              (band(Menu.ItemStatus(i), 2) == 2 and '√' or ' ') ..
              ss
     end
    end
   end
   return table.concat (s, ';\n')
  end -- MenuItemsShow
  local mm=MenuItemsShow()
  if next(aItems) then
   if mm and mm:len() > 0 then
    far.Show( TabToStr(aItems, ';\n', ' '), '----------------',Area.Current, mm)
   else
    far.Show( TabToStr(aItems, ';\n', ' '))
   end
  else
   if mm and mm:len() > 0 then
    far.Show( Area.Current, mm)
   end
  end
 end -- DlgItemsShow
 local ss=Area.Current
 if ss == 'Dialog' then
  local hDlg = far.AdvControl("ACTL_GETWINDOWINFO").Id
  ss = ss .. ' ('..Dlg.Id..')'
  if far.Message('Area.Current='..ss, 'Параметры диалога', 'Показать элементы;Закрыть') == 1 then
   DlgItemsShow(hDlg)
  end
 elseif ss == 'Menu' or ss == 'MainMenu' or ss == 'UserMenu' then
  local hDlg = far.AdvControl("ACTL_GETWINDOWINFO").Id
  if hDlg then
   local Menu_Id, nhDlg=Menu.Id, tonumber(hDlg) or 0
   if far.Message('Area.Current='..ss..' ('.. (Menu.Id or win.Uuid(panel.GetPanelInfo(0).OwnerGuid)):upper()..')'..
                  (nhDlg ~= 0 and '\nhDlg='..tostring(hDlg) or ''), 'Параметры диалога', Menu_Id and 'Показать элементы;Закрыть') == 1 then
    DlgItemsShow(hDlg)
   end
  else
   far.Show('Area.Current='..ss..' ('..Menu.Id..')')
  end
 else
  local hDlg = far.AdvControl("ACTL_GETWINDOWINFO").Id
  if hDlg then
   local Menu_Id, nhDlg = Menu.Id, tonumber(hDlg) or 0
   if far.Message('Area.Current='..ss..' ('.. (Menu_Id or win.Uuid(panel.GetPanelInfo(0).OwnerGuid)):upper() ..')'..
                  (nhDlg ~= 0 and '\nhDlg='..tostring(hDlg) or ''), 'Параметры диалога', Menu_Id and 'Показать элементы;Закрыть') == 1 then
    DlgItemsShow(hDlg)
   end
  else
   far.Show('Area.Current='..ss)
  end
 end
end;
}

--[=[
local TabUtils=require"Bax.TabUtils"
local TabToStr=TabUtils.TableToString

local items
local function fff()
  items={
         {text='1'};
         {text='2'};
         {text='3'};
         {text='4'};
         {text='5'};
         {text='6'};
         {text='7'};
         {text='8'};
         {text='9'};
         {text='10'};
         {text='11'};
         {text='12'};
         {text='13'};
         {text='14'};
         {text='15'};
         {text='16'};
         {text='17'};
         {text='18'};
         {text='19'};
         {text='20'};
        }
  local aRes={far.Menu({Id=win.Uuid"1B8DCBF9-012D-4821-9E8F-637FBB29A108"},items,{{BreakKey="Tab"; Eval=function() far.Show('Eval') end}})}
  far.Show(TabToStr(aRes,';\n',' '))
  if type(aRes[1]) == 'table' and aRes[1].Eval then
   --[[*D*]]far.Show('31: aRes[1].BreakKey'..type(aRes[1].BreakKey))
   aRes[1].Eval()
  end
end -- fff

Macro{
--  id="";
  area="Editor";
  key="CtrlShiftW";
--  description="";
--  filemask="";
  flags="";
--  priority=50;
--  sortpriority=50;
action=function()
 fff()
end;
}
--]=]